/***************************************************************************
                          configurationreader.h  -  description
                             -------------------
    begin                : Son Nov 10 2002
    copyright            : (C) 2002 by Andr Simon
    email                : andre.simon1@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONFIGURATIONREADER_H
#define CONFIGURATIONREADER_H

#include <string>
#include <sstream>
#include <map>

using namespace std;

/**Methoden zum Auslesen von Textkonfigurationen
  *@author Andr Simon
  */

typedef map<string, string> ParameterMap;

class ConfigurationReader
  {
  public:
    ConfigurationReader(const string & configuration_path, bool complain);
    ~ConfigurationReader();
    string &getParameter(const string & paramName);
    bool found();
    stringstream *getParameterNames();
  private:
    ParameterMap parameterMap;
    bool fileFound;
    //  StringStream mit Parameternamen, durch " " getrennt
    stringstream parameterNames;
  };

#endif
