/***************************************************************************
                          documentstyle.h  -  description
                             -------------------
    begin                : Son Nov 10 2002
    copyright            : (C) 2002 by Andr Simon
    email                : andre.simon1@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DOCUMENTSTYLE_H
#define DOCUMENTSTYLE_H

#include "elementstyle.h"
#include "stylecolour.h"
#include <string>


/**Enthlt Informationen ber die Formatierung der Quellldatei
  *@author Andr Simon
  */

using namespace std;

class DocumentStyle
  {
  private:
    ElementStyle *comment, *keyword, *str, *dstr,
    *escapeChar, *number, *directive, *type, *line;
    StyleColour *bgColour, *defaultColour;
    string fontsize;
    bool fileFound;

  public:
    DocumentStyle(const string & styleDefinitionFile);
    bool load(const string & styleDefinitionFile);
    //  DocumentStyle::DocumentStyle (const DocumentStyle & ds);
    ~DocumentStyle();
    string getFontSize() const;
    StyleColour* getBgColour() const;
    StyleColour* getDefaultColour() const;
    ElementStyle* getCommentStyle() const;
    ElementStyle* getKeywordStyle() const;
    ElementStyle* getStringStyle() const;
    ElementStyle* getDirectiveStringStyle() const;
    ElementStyle* getEscapeCharStyle() const;
    ElementStyle* getNumberStyle() const;
    ElementStyle* getDirectiveStyle() const;
    ElementStyle* getTypeStyle() const;
    ElementStyle* getLineStyle() const;

    StyleColour* getCommentColour() const;
    StyleColour* getKeywordColour() const;
    StyleColour* getStringColour() const;
    StyleColour* getDirectiveStringColour() const;
    StyleColour* getEscapeCharColour() const;
    StyleColour* getNumberColour() const;
    StyleColour* getDirectiveColour() const;
    StyleColour* getTypeColour() const;
    StyleColour* getLineColour() const;

    bool found() const ;

  };

#endif
