/***************************************************************************
                          latexcode.h  -  description
                             -------------------
    begin                : Mit Jul 24 2002
    copyright            : (C) 2002 by Andr Simon
    email                : andre.simon1@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LATEXCODE_H
#define LATEXCODE_H

#include "codeparser.h"
#include <string>

/**Klasse mit Methoden zur LaTeX-Ausgabe
  *@author Andr Simon
  */

class LatexCode : public highlight::CodeParser
  {
  public:
    LatexCode(highlight::LanguageDefinition &langDef, const string &cssStyle,
              bool printLineNumbers=false, int numSpaces=0);
    LatexCode();
    ~LatexCode();

    void printHeader(const string & title);
    void printFooter();
    void printBody();    

  private: // Private methods
    string styleDefinition;
    /** Gibt Tex-Code der Sonderzeichen zurueck */
    virtual string maskCharacter( char );
    string formatStyleAttributes(const string & elemName, StyleColour * col,ElementStyle * elem=NULL);

    bool isOpeningStringDelim;
  };

#endif
