/***************************************************************************
                          rtfcode.h  -  description
                             -------------------
    begin                : Die Jul 9 2002
    copyright            : (C) 2002 by Andr Simon
    email                : andre.simon1@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RTFCODE_H
#define RTFCODE_H

#include "codeparser.h"
#include <string>

/**
  *@author Andr Simon
  */

class RtfCode : public highlight::CodeParser
  {
  public:
    RtfCode( highlight::LanguageDefinition &langDef,const string &cssStyle,
             bool printLineNumbers=false, int numSpaces=0);
    RtfCode();
    ~RtfCode();

    void printHeader(const string & title);
    void printFooter();
    void printBody();

  private:
    string styleDefinition;
    /** Gibt RTF-Code der Sonderzeichen zurueck */
    virtual string maskCharacter( char );
    string  formatStyleAttributes( StyleColour * col);

    /** gibt RTF-"Tags" zurueck (Farbindex+bold+kursiv)*/
    string getOpenTag(int styleNumber,ElementStyle * elem=NULL);
    string getCloseTag(ElementStyle * elem=NULL);
  };

#endif
