/***************************************************************************
                          stringtools.cpp  -  description
                             -------------------
    begin                : Mon Dec 10 2001
    copyright            : (C) 2001 by Andr Simon
    email                : andre.simon1@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <string>
#include "stringtools.h"

using namespace std;
#include <ctype.h>


// Make a lowercase copy of s:
// (C) Bruce Eckel, Thinking in C++ Vol 2

string StringTools::lowerCase(string& s)
{
  char* buf = new char[s.length()];
  s.copy(buf, s.length());
  for(unsigned int i = 0; i < s.length(); i++)
    buf[i] = tolower(buf[i]);
  string r(buf, s.length());
  delete buf;
  return r;
}

/** wandelt String s in Integer um */
int StringTools::str2int(string &s)
{
  int intVal=0;
  bool neg = false;
  for (unsigned int i=0; i< s.length(); i++)
    {
      if (s[i]=='-')
        neg= ! neg;
      else
        intVal= (intVal*10)+(s[i]-48);
    }
  return (neg)? -intVal: intVal;
}

/** wandelt char* s in Integer um */
int StringTools::str2int(char *s)
{
  int intVal=0;
  bool neg = false;
  unsigned int i=0;
  while ( *(s+i) != '\0')
    {
      if (*(s+i)=='-')
        neg= ! neg;
      else
        intVal= (intVal*10)+(*(s+i)-48);
      i++;
    }
  return (neg)? -intVal: intVal;
}

/** gibt integer >=0 als  String zurueck,
  size=Mindestlaenge des ergebnisstrings,
	Rest wird mit Leerzeichen (spaceStr) aufgefuellt
 */
string StringTools::int2str(int integer, int size, const string spaceStr)
{
  int d;
  string s, z;
  do
    {
      d= integer % 10;
      z=d+'0';
      s.insert(0, z);

      integer/=10;
    }
  while (integer);

  for (int i=s.length(); i< size; i++)
    s.insert( 0 , spaceStr);

  return s;
}


/** gibt true zurueck, falls c eine Ziffer ist*/
bool StringTools::isDigit(char c)
{
  return ((c>='0') && (c<='9'));
}
/** gibt True zurueck, falls c ein Buchstabe/Underscore ist */
bool StringTools::isAlpha(char c)
{
  return ((toupper(c) >= 'A') && (toupper(c) <= 'Z') || c == '_');
}
/** gibt TRUE zurueck, wenn c Space oder Tab ist */
bool StringTools::isWhitespace (char c)
{
  return ((c=='\t') || (c==' '));
}


string StringTools::trimRight(const string &value)
 {
  string::size_type where = value.find_last_not_of(" \n\r\t");
  
  if (where == string::npos)
   // string has nothing but space
   return string();
   
  if (where == (value.length() - 1))
   // string has no trailing space, don't copy its contents
   return value;
   
  return value.substr(0, where + 1);
 }

