/***************************************************************************
                          stringtools.h  -  description
                             -------------------
    begin                : Mon Dec 10 2001
    copyright            : (C) 2001 by Andr Simon
    email                : andre.simon1@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef STRINGTOOLS_H
#define STRINGTOOLS_H

#include <string>

using namespace std;

/**Methoden zur Stringbearbeitung
  *@author Andr Simon
  */

namespace StringTools
  {

  /** gibt str in Kleinbuchstaben zurueck */
  string lowerCase(string &s);

  /** wandelt String s in Integer um */
  int str2int(string &s);

  /** gibt integer als  String zurueck */
  string int2str(int integer, int size=0, const string spaceStr= " ");

  /** gibt true zurueck, falls c eine Ziffer ist*/
  bool isDigit(char c);

  /** gibt True zurueck, falls c ein Buchstabe ist */
  bool isAlpha(char c);

  /** gibt TRUE zurueck, wenn c Space oder Tab ist */
  bool isWhitespace (char c);

  /** wandelt String s in Integer um */
  int str2int(char *s);
  
  /* entfernt whitespace von stringende*/
  string StringTools::trimRight(const string &);
};

#endif


