/***************************************************************************
                          texcode.h  -  description
                             -------------------
    begin                : Mit Jul 24 2002
    copyright            : (C) 2002 by Andr Simon
    email                : andre.simon1@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TEXCODE_H
#define TEXCODE_H

#include "codeparser.h"
#include <string>

/**Klasse mit Methoden zur LaTex-Ausgabe
  *@author Andr Simon
  */

class TexCode : public highlight::CodeParser
  {
  public:
    TexCode(highlight::LanguageDefinition &langDef,const string &cssStyle,
            bool printLineNumbers=false, int numSpaces=0);
    TexCode();
    ~TexCode();
    /** No descriptions */
    void printHeader(const string & title);
    /** No descriptions */
    void printFooter();
    /** gibt Tex-Text aus */
    void printBody();
  private: // Private methods
    /** Gibt Tex-Code der Sonderzeichen zurueck */
    virtual string maskCharacter( char );

    string getOpenTag(StyleColour *col, ElementStyle * elem=NULL);
  };

#endif
