#!/usr/bin/python
#
#   PyHighlight -- A PyQt Frontend for highlight                       
#                             -------------------
#    begin                : 25.09.2003
#    copyright            : (C) 2003 by Andre Simon
#    email                : andre.simon1@gmx.de
#
##########################################################################
#                                                                       
#    This program is free software; you can redistribute it and/or modify  
#    it under the terms of the GNU General Public License as published by  
#    the Free Software Foundation; either version 2 of the License, or    
#    (at your option) any later version.                                  
#                                                                         
 


#
# Form implementation generated from reading ui file 'highlightForm.ui'
#
# Created: Die Sep 23 21:04:42 2003
#      by: The PyQt User Interface Compiler (pyuic)
#

from qt import *
import os
import string
import sys

GUI_VERSION = "0.1"

class Form1(QMainWindow):
       
    def __init__(self,parent = None,name = None,fl = 0):    
        
        # Command string
        self.hlCmd="highlight --deletetabs=2 "
	
        QMainWindow.__init__(self,parent,name,fl)
        self.statusbar=self.statusBar()
	self.statusbar.message("Ready.")

        if not name:
            self.setName("PyHighlight " + GUI_VERSION)

        self.setCentralWidget(QWidget(self,"qt_central_widget"))

        self.textLabel4 = QLabel(self.centralWidget(),"textLabel4")
        self.textLabel4.setGeometry(QRect(230,229,130,21))

        self.editCssOutfile = QLineEdit("highlight.css", self.centralWidget(),"editCssOutfile")
        self.editCssOutfile.setGeometry(QRect(230,249,151,23))	

        self.textLabel5 = QLabel(self.centralWidget(),"textLabel5")
        self.textLabel5.setGeometry(QRect(230,289,161,21))

        self.textLabel6 = QLabel(self.centralWidget(),"textLabel6")
        self.textLabel6.setGeometry(QRect(230,339,131,21))

        self.themeChoice = QComboBox(0,self.centralWidget(),"themeChoice")
        self.themeChoice.setGeometry(QRect(230,369,150,21))
        themes = os.listdir('/usr/share/highlight/themes/')        
        for theme in themes:
           themeName = string.split(theme,'.',2)
           self.themeChoice.insertItem(themeName[0])

        self.butSource = QPushButton(self.centralWidget(),"butSource")
        self.butSource.setGeometry(QRect(60,19,90,20))

        self.listBox = QListBox(self.centralWidget(),"listBox")
        self.listBox.setGeometry(QRect(20,50,170,350))

        self.butRemoveFromList = QPushButton(self.centralWidget(),"butRemoveFromList")
        self.butRemoveFromList.setGeometry(QRect(50,410,110,21))

        self.butOutDir = QPushButton(self.centralWidget(),"butOutDir")
        self.butOutDir.setGeometry(QRect(50,459,110,21))

        self.outDir = QLineEdit(self.centralWidget(),"outDir")
        self.outDir.setGeometry(QRect(30,489,161,23))

        self.outputFormat = QButtonGroup(self.centralWidget(),"outputFormat")
        self.outputFormat.setGeometry(QRect(220,20,160,90))

        self.radioButton5 = QRadioButton(self.outputFormat,"radioButton5")
        self.radioButton5.setGeometry(QRect(10,60,104,21))

        self.radioButton3 = QRadioButton(self.outputFormat,"radioButton3")
        self.radioButton3.setGeometry(QRect(10,40,70,21))

        self.radioButton4 = QRadioButton(self.outputFormat,"radioButton4")
        self.radioButton4.setGeometry(QRect(80,40,50,20))

        self.radioButton2 = QRadioButton(self.outputFormat,"radioButton2")
        self.radioButton2.setGeometry(QRect(80,20,70,20))

        self.radioButton1 = QRadioButton(self.outputFormat,"radioButton1")
        self.radioButton1.setGeometry(QRect(10,20,60,21))

        self.includeCss = QCheckBox(self.centralWidget(),"includeCss")
        self.includeCss.setGeometry(QRect(230,179,160,21))

        self.fragment = QCheckBox(self.centralWidget(),"fragment")
        self.fragment.setGeometry(QRect(230,159,160,21))

        self.linenumbers = QCheckBox(self.centralWidget(),"linenumbers")
        self.linenumbers.setGeometry(QRect(230,119,150,21))

        self.attachAnchors = QCheckBox(self.centralWidget(),"attachAnchors")
        self.attachAnchors.setGeometry(QRect(230,139,160,21))

        #self.generateHtmlIndex = QCheckBox(self.centralWidget(),"generateHtmlIndex")
        #self.generateHtmlIndex.setGeometry(QRect(230,200,140,21))

        self.butStart = QPushButton(self.centralWidget(),"butStart")
        self.butStart.setGeometry(QRect(230,449,150,30))

        self.editCssInfile = QLineEdit(self.centralWidget(),"editCssInfile")
        self.editCssInfile.setGeometry(QRect(230,309,110,23))

        self.butChooseCssInfile = QPushButton(self.centralWidget(),"butChooseCssInfile")
        self.butChooseCssInfile.setGeometry(QRect(350,310,31,21))

        self.reformatCode = QCheckBox(self.centralWidget(),"reformatCode")
        self.reformatCode.setGeometry(QRect(230,409,80,21))

        self.reformatChoice = QComboBox(0,self.centralWidget(),"reformatChoice")
        self.reformatChoice.setEnabled(0)
        self.reformatChoice.setGeometry(QRect(310,409,70,21))

        self.progress = QProgressBar(self.centralWidget(),"progress")
        self.progress.setGeometry(QRect(230,490,150,24))

        self.fileOpenAction = QAction(self,"fileOpenAction")   
        self.fileExitAction = QAction(self,"fileExitAction")        
        self.helpIndexAction = QAction(self,"helpIndexAction")
	self.helpChangeLogAction = QAction(self,"helpChangeLogAction")
        self.helpAboutAction = QAction(self,"helpAboutAction")

        self.menubar = QMenuBar(self,"menubar")

        self.fileMenu = QPopupMenu(self)

        self.fileOpenAction.addTo(self.fileMenu)
        self.fileMenu.insertSeparator()
        self.fileExitAction.addTo(self.fileMenu)
        self.menubar.insertItem("",self.fileMenu,0)

        self.helpMenu = QPopupMenu(self)        
        self.helpIndexAction.addTo(self.helpMenu)
	self.helpChangeLogAction.addTo(self.helpMenu)
        self.helpMenu.insertSeparator()
        self.helpAboutAction.addTo(self.helpMenu)
        self.menubar.insertItem("",self.helpMenu,1)

        self.languageChange()

        self.resize(QSize(422,574).expandedTo(self.minimumSizeHint()))

        self.connect(self.helpIndexAction,SIGNAL("activated()"),self.helpIndex)
	self.connect(self.helpChangeLogAction,SIGNAL("activated()"),self.helpChangelog)
	self.connect(self.fileOpenAction,SIGNAL("activated()"),self.openFiles)        
        self.connect(self.helpAboutAction,SIGNAL("activated()"),self.helpAbout)
	self.connect(self.butSource,SIGNAL("clicked()"),self.openFiles)
	self.connect(self.butRemoveFromList,SIGNAL("clicked()"),self.clearFileList)
	self.connect(self.butChooseCssInfile,SIGNAL("clicked()"),self.chooseCssInFile)	
	self.connect(self.butOutDir,SIGNAL("clicked()"),self.chooseOutDir)
	self.connect(self.reformatCode,SIGNAL("clicked()"),self.activateReformat)	
	self.connect(self.butStart,SIGNAL("clicked()"),self.start)
	
	self.connect(self.radioButton1,SIGNAL("clicked()"),self.plausiTests)
	self.connect(self.radioButton2,SIGNAL("clicked()"),self.plausiTests)
	self.connect(self.radioButton3,SIGNAL("clicked()"),self.plausiTests)
	self.connect(self.radioButton4,SIGNAL("clicked()"),self.plausiTests)
	self.connect(self.radioButton5,SIGNAL("clicked()"),self.plausiTests)
		

    def languageChange(self):
        self.setCaption(self.tr("PyHighlight " + GUI_VERSION))
        self.textLabel4.setText(self.tr("Referenced CSS file"))
        self.textLabel5.setText(self.tr("File to include in CSS file"))
        self.textLabel6.setText(self.tr("Colour theme"))
        self.butSource.setText(self.tr("Choose files"))
	QToolTip.add(self.butSource,self.tr("Add source files"))        
        self.listBox.clear()        
        self.butRemoveFromList.setText(self.tr("Clear file list"))
        self.butOutDir.setText(self.tr("Output directory"))
	QToolTip.add(self.butOutDir,self.tr("Choose an output directory"))
        self.outputFormat.setTitle(self.tr("Output formats"))
	QToolTip.add(self.outputFormat,self.tr("Choose an output format"))
        self.radioButton5.setText(self.tr("RTF"))
        self.radioButton3.setText(self.tr("LaTeX"))
        self.radioButton4.setText(self.tr("TeX"))
        self.radioButton2.setText(self.tr("XHTML"))
        self.radioButton1.setText(self.tr("HTML"))
	self.radioButton1.setChecked(True)
        self.includeCss.setText(self.tr("include CSS in output"))
        self.fragment.setText(self.tr("omit header and footer"))
        self.linenumbers.setText(self.tr("include line numbers"))
        self.attachAnchors.setText(self.tr("attach anchors to lines"))
        #self.generateHtmlIndex.setText(self.tr("generate index file"))
        self.butStart.setText(self.tr("Convert"))
        self.butChooseCssInfile.setText(self.tr("..."))
        self.reformatCode.setText(self.tr("Reformat"))
        self.reformatChoice.clear()
        self.reformatChoice.insertItem(self.tr("ansi"))
        self.reformatChoice.insertItem(self.tr("gnu"))
        self.reformatChoice.insertItem(self.tr("java"))
        self.reformatChoice.insertItem(self.tr("kr"))
        self.reformatChoice.insertItem(self.tr("linux"))        
        self.fileOpenAction.setText(self.tr("Open"))
        self.fileOpenAction.setMenuText(self.tr("&Open..."))
        self.fileOpenAction.setAccel(self.tr("Ctrl+O"))
        self.fileExitAction.setText(self.tr("Exit"))
        self.fileExitAction.setMenuText(self.tr("E&xit"))
        self.fileExitAction.setAccel(QString.null)        
        self.helpIndexAction.setText(self.tr("Help"))
        self.helpIndexAction.setMenuText(self.tr("&Help"))
        self.helpIndexAction.setAccel(QString.null)
	self.helpChangeLogAction.setText(self.tr("ChangeLog"))
        self.helpChangeLogAction.setMenuText(self.tr("&ChangeLog"))
        self.helpChangeLogAction.setAccel(QString.null)
        self.helpAboutAction.setText(self.tr("About"))
        self.helpAboutAction.setMenuText(self.tr("&About"))
        self.helpAboutAction.setAccel(QString.null)
        self.menubar.findItem(0).setText(self.tr("&File"))
        self.menubar.findItem(1).setText(self.tr("&Help"))

    # shows text file with kedit	 
    def showFile(self, path):
        catCmd = "kedit "+path
        catOut = os.system(catCmd+"&")        
		    
    def helpIndex(self):
        self.showFile("/usr/share/highlight/README")
        
    def helpChangelog(self):
        self.showFile("/usr/share/highlight/ChangeLog")

    def helpAbout(self):
        aboutMsg=os.popen("highlight --version")
	aboutStr =  " PyHighlight "+ GUI_VERSION+"\n"
	aboutStr += " Copyright (C) 2003 Andre Simon <andre.simon1@gmx.de>\n\n Highlight information:\n"	
        aboutStr += string.join(aboutMsg.readlines())  
	aboutMsg.close()
        QMessageBox.about(self, "About Highlight", aboutStr)
		 
    def openFiles(self):
        files=QFileDialog.getOpenFileNames("", "Source files (*.*)",self)
	self.listBox.insertStringList(files)

    def clearFileList(self):        
	self.listBox.clear()

    def chooseCssInFile(self):
        cssfile=QFileDialog.getOpenFileName("","CSS Files (*.css)",self)
	self.editCssInfile.setText(cssfile)
	
    def chooseOutDir(self):
        outdir=QFileDialog.getExistingDirectory("",self, "get out dir","Choose output directory",True)
	self.outDir.setText(outdir)
	
    def activateReformat(self):
        self.reformatChoice.setEnabled(self.reformatCode.isChecked())
	
    def plausiTests(self):
        if self.radioButton1.isChecked() or self.radioButton2.isChecked():	   
           self.includeCss.setEnabled(True)
           self.fragment.setEnabled(True)
           self.linenumbers.setEnabled(True)
           self.attachAnchors.setEnabled(True)
           #self.generateHtmlIndex.setEnabled(True)
	   self.textLabel4.setEnabled(True)
	   self.textLabel5.setEnabled(True)
	   self.textLabel5.setEnabled(True)	   
	   self.butChooseCssInfile.setEnabled(True)
	   
	else:
	   self.includeCss.setEnabled(False)
	   self.includeCss.setChecked(False)
           self.fragment.setEnabled(True)
           self.linenumbers.setEnabled(True)
           self.attachAnchors.setEnabled(False)
	   self.attachAnchors.setChecked(False)
           #self.generateHtmlIndex.setEnabled(False)
	   #self.generateHtmlIndex.setChecked(False)
	   self.textLabel4.setEnabled(False)
	   self.textLabel5.setEnabled(False)
	   self.textLabel5.setEnabled(False)	   
	   self.butChooseCssInfile.setEnabled(False)
	   
    def executeHighlight(self, cmd):
            tochild, fromchild, childerror = os.popen3(cmd)
            err = childerror.readlines()
	    errorOccoured=0
            if len(err) > 0:
	       msg=string.join(err)
               QMessageBox.warning(self, "ERROR", msg, 0)
	       errorOccoured=1                                       
	       
    
    def start(self):
         infileCount=self.listBox.count()
         if infileCount==0:
	     QMessageBox.warning(self, "ERROR", "Please choose input files.", 0)
	     return
	     
	 if str(self.outDir.text())=="":  
	     QMessageBox.warning(self, "ERROR", "Please specify output directory", 0)   
	     return
    
	 if self.radioButton2.isChecked():
	      self.hlCmd += "--xhtml "
	 elif self.radioButton3.isChecked():
	      self.hlCmd += "--latex "
	 elif self.radioButton4.isChecked():
	      self.hlCmd += "--tex "
	 elif self.radioButton5.isChecked():
              self.hlCmd += "--rtf "
  
	 if self.includeCss.isChecked():
	      self.hlCmd += "--includecss "      
	      
	 if self.fragment.isChecked():
	      self.hlCmd += "--fragment "      
	      
	 if self.linenumbers.isChecked():
	      self.hlCmd += "--linenumbers "      
	      
	 if self.attachAnchors.isChecked():
	      self.hlCmd += "--anchors "      
	      
	 #if self.generateHtmlIndex.isChecked():
	 #     self.hlCmd += "--printindex "      
	      
	 if self.includeCss.isChecked():
	      self.hlCmd += "--includecss "	        
	      
	 if str(self.editCssOutfile.text())!="":
	      self.hlCmd += "--css-outfile="
	      self.hlCmd += str(self.editCssOutfile.text())
	      self.hlCmd += " "
	      
	 if str(self.editCssInfile.text())!="":
	      self.hlCmd += "--css-infile="
	      self.hlCmd += str(self.editCssInfile.text())
	      self.hlCmd += " "
	               
	 self.hlCmd += "--style="     
	 self.hlCmd += str(self.themeChoice.currentText())
         self.hlCmd += " "
	 
	 if (self.reformatCode.isChecked()):
	    self.hlCmd += "--format-style="     
	    self.hlCmd += str(self.reformatChoice.currentText())
            self.hlCmd += " "
	    
         self.hlCmd += "--outdir="     
	 self.hlCmd += str(self.outDir.text()) 
	 self.hlCmd += " "
            
	 progressInc = int (100 / infileCount)
	 progressSum = 0
	 self.statusbar.message("Processing "+str(infileCount)+" files..")
	 for i in range(infileCount):
	    progressSum += progressInc
	    self.progress.setProgress(progressSum)	
	    item = self.listBox.item(i)
	    self.executeHighlight( self.hlCmd + str(item.text()))
	    print self.hlCmd + str(item.text())
	    
         self.progress.setProgress(100)
	 QMessageBox.about(self, "Done.", "Process completed.")  
	 self.progress.setProgress(0)
	 self.statusbar.message("Ready.")
	 
	 
if __name__ == '__main__':	 
  Application = QApplication(sys.argv)
  QObject.connect(Application,SIGNAL('lastWindowClosed()'),Application,SLOT('quit()'))
  MainWindow = Form1()
  Application.setMainWidget(MainWindow)
  MainWindow.show()
  Application.exec_loop()
